(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
	(factory((global.Materialish = {}),global.React));
}(this, (function (exports,React) { 'use strict';

	var React__default = 'default' in React ? React['default'] : React;

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var classnames = createCommonjsModule(function (module) {
	/*!
	  Copyright (c) 2016 Jed Watson.
	  Licensed under the MIT License (MIT), see
	  http://jedwatson.github.io/classnames
	*/
	/* global define */

	(function () {

		var hasOwn = {}.hasOwnProperty;

		function classNames () {
			var classes = [];

			for (var i = 0; i < arguments.length; i++) {
				var arg = arguments[i];
				if (!arg) continue;

				var argType = typeof arg;

				if (argType === 'string' || argType === 'number') {
					classes.push(arg);
				} else if (Array.isArray(arg)) {
					classes.push(classNames.apply(null, arg));
				} else if (argType === 'object') {
					for (var key in arg) {
						if (hasOwn.call(arg, key) && arg[key]) {
							classes.push(key);
						}
					}
				}
			}

			return classes.join(' ');
		}

		if ('object' !== 'undefined' && module.exports) {
			module.exports = classNames;
		} else if (typeof undefined === 'function' && typeof undefined.amd === 'object' && undefined.amd) {
			// register as 'classnames', consistent with npm package name
			undefined('classnames', [], function () {
				return classNames;
			});
		} else {
			window.classNames = classNames;
		}
	}());
	});

	var classCallCheck = function (instance, Constructor) {
	  if (!(instance instanceof Constructor)) {
	    throw new TypeError("Cannot call a class as a function");
	  }
	};

	var _extends = Object.assign || function (target) {
	  for (var i = 1; i < arguments.length; i++) {
	    var source = arguments[i];

	    for (var key in source) {
	      if (Object.prototype.hasOwnProperty.call(source, key)) {
	        target[key] = source[key];
	      }
	    }
	  }

	  return target;
	};

	var inherits = function (subClass, superClass) {
	  if (typeof superClass !== "function" && superClass !== null) {
	    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
	  }

	  subClass.prototype = Object.create(superClass && superClass.prototype, {
	    constructor: {
	      value: subClass,
	      enumerable: false,
	      writable: true,
	      configurable: true
	    }
	  });
	  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
	};

	var objectWithoutProperties = function (obj, keys) {
	  var target = {};

	  for (var i in obj) {
	    if (keys.indexOf(i) >= 0) continue;
	    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
	    target[i] = obj[i];
	  }

	  return target;
	};

	var possibleConstructorReturn = function (self, call) {
	  if (!self) {
	    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	  }

	  return call && (typeof call === "object" || typeof call === "function") ? call : self;
	};

	var Ripple = function (_Component) {
	  inherits(Ripple, _Component);

	  function Ripple() {
	    var _temp, _this, _ret;

	    classCallCheck(this, Ripple);

	    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	      args[_key] = arguments[_key];
	    }

	    return _ret = (_temp = (_this = possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
	      active: false,
	      top: 0,
	      left: 0
	    }, _this.onClick = function (e) {
	      var wasMouseClick = e.nativeEvent.x && e.nativeEvent.y;
	      var left = wasMouseClick ? e.nativeEvent.layerX + 'px' : '50%';
	      var top = wasMouseClick ? e.nativeEvent.layerY + 'px' : '50%';

	      _this.setState({
	        active: false,
	        top: top,
	        left: left
	      });

	      _this.activeTimeout = setTimeout(function () {
	        _this.setState({
	          active: true
	        });
	      }, 25);
	    }, _temp), possibleConstructorReturn(_this, _ret);
	  }

	  Ripple.prototype.render = function render() {
	    var _state = this.state,
	        active = _state.active,
	        top = _state.top,
	        left = _state.left;


	    var classname = classnames('mt-ripple', {
	      'mt-ripple-active': active
	    });
	    var styles = {
	      '--mt-ripple-top': top,
	      '--mt-ripple-left': left
	    };

	    return React__default.createElement('span', { style: styles, className: classname, onClick: this.onClick });
	  };

	  Ripple.prototype.componentWillUnmount = function componentWillUnmount() {
	    clearTimeout(this.activeTimeout);
	  };

	  return Ripple;
	}(React.Component);

	/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 * 
	 */

	function makeEmptyFunction(arg) {
	  return function () {
	    return arg;
	  };
	}

	/**
	 * This function accepts and discards inputs; it has no side effects. This is
	 * primarily useful idiomatically for overridable function endpoints which
	 * always need to be callable, since JS lacks a null-call idiom ala Cocoa.
	 */
	var emptyFunction = function emptyFunction() {};

	emptyFunction.thatReturns = makeEmptyFunction;
	emptyFunction.thatReturnsFalse = makeEmptyFunction(false);
	emptyFunction.thatReturnsTrue = makeEmptyFunction(true);
	emptyFunction.thatReturnsNull = makeEmptyFunction(null);
	emptyFunction.thatReturnsThis = function () {
	  return this;
	};
	emptyFunction.thatReturnsArgument = function (arg) {
	  return arg;
	};

	var emptyFunction_1 = emptyFunction;

	/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	/**
	 * Use invariant() to assert state which your program assumes to be true.
	 *
	 * Provide sprintf-style format (only %s is supported) and arguments
	 * to provide information about what broke and what you were
	 * expecting.
	 *
	 * The invariant message will be stripped in production, but the invariant
	 * will remain to ensure logic does not differ in production.
	 */

	var validateFormat = function validateFormat(format) {};

	{
	  validateFormat = function validateFormat(format) {
	    if (format === undefined) {
	      throw new Error('invariant requires an error message argument');
	    }
	  };
	}

	function invariant(condition, format, a, b, c, d, e, f) {
	  validateFormat(format);

	  if (!condition) {
	    var error;
	    if (format === undefined) {
	      error = new Error('Minified exception occurred; use the non-minified dev environment ' + 'for the full error message and additional helpful warnings.');
	    } else {
	      var args = [a, b, c, d, e, f];
	      var argIndex = 0;
	      error = new Error(format.replace(/%s/g, function () {
	        return args[argIndex++];
	      }));
	      error.name = 'Invariant Violation';
	    }

	    error.framesToPop = 1; // we don't care about invariant's own frame
	    throw error;
	  }
	}

	var invariant_1 = invariant;

	/**
	 * Similar to invariant but only logs a warning if the condition is not met.
	 * This can be used to log issues in development environments in critical
	 * paths. Removing the logging code for production environments will keep the
	 * same logic and follow the same code paths.
	 */

	var warning = emptyFunction_1;

	{
	  var printWarning = function printWarning(format) {
	    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
	      args[_key - 1] = arguments[_key];
	    }

	    var argIndex = 0;
	    var message = 'Warning: ' + format.replace(/%s/g, function () {
	      return args[argIndex++];
	    });
	    if (typeof console !== 'undefined') {
	      console.error(message);
	    }
	    try {
	      // --- Welcome to debugging React ---
	      // This error was thrown as a convenience so that you can use this stack
	      // to find the callsite that caused this warning to fire.
	      throw new Error(message);
	    } catch (x) {}
	  };

	  warning = function warning(condition, format) {
	    if (format === undefined) {
	      throw new Error('`warning(condition, format, ...args)` requires a warning ' + 'message argument');
	    }

	    if (format.indexOf('Failed Composite propType: ') === 0) {
	      return; // Ignore CompositeComponent proptype check.
	    }

	    if (!condition) {
	      for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
	        args[_key2 - 2] = arguments[_key2];
	      }

	      printWarning.apply(undefined, [format].concat(args));
	    }
	  };
	}

	var warning_1 = warning;

	/*
	object-assign
	(c) Sindre Sorhus
	@license MIT
	*/
	/* eslint-disable no-unused-vars */
	var getOwnPropertySymbols = Object.getOwnPropertySymbols;
	var hasOwnProperty = Object.prototype.hasOwnProperty;
	var propIsEnumerable = Object.prototype.propertyIsEnumerable;

	function toObject(val) {
		if (val === null || val === undefined) {
			throw new TypeError('Object.assign cannot be called with null or undefined');
		}

		return Object(val);
	}

	function shouldUseNative() {
		try {
			if (!Object.assign) {
				return false;
			}

			// Detect buggy property enumeration order in older V8 versions.

			// https://bugs.chromium.org/p/v8/issues/detail?id=4118
			var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
			test1[5] = 'de';
			if (Object.getOwnPropertyNames(test1)[0] === '5') {
				return false;
			}

			// https://bugs.chromium.org/p/v8/issues/detail?id=3056
			var test2 = {};
			for (var i = 0; i < 10; i++) {
				test2['_' + String.fromCharCode(i)] = i;
			}
			var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
				return test2[n];
			});
			if (order2.join('') !== '0123456789') {
				return false;
			}

			// https://bugs.chromium.org/p/v8/issues/detail?id=3056
			var test3 = {};
			'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
				test3[letter] = letter;
			});
			if (Object.keys(Object.assign({}, test3)).join('') !==
					'abcdefghijklmnopqrst') {
				return false;
			}

			return true;
		} catch (err) {
			// We don't expect any of the above to throw, but better to be safe.
			return false;
		}
	}

	var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
		var from;
		var to = toObject(target);
		var symbols;

		for (var s = 1; s < arguments.length; s++) {
			from = Object(arguments[s]);

			for (var key in from) {
				if (hasOwnProperty.call(from, key)) {
					to[key] = from[key];
				}
			}

			if (getOwnPropertySymbols) {
				symbols = getOwnPropertySymbols(from);
				for (var i = 0; i < symbols.length; i++) {
					if (propIsEnumerable.call(from, symbols[i])) {
						to[symbols[i]] = from[symbols[i]];
					}
				}
			}
		}

		return to;
	};

	/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */

	var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

	var ReactPropTypesSecret_1 = ReactPropTypesSecret;

	{
	  var invariant$1 = invariant_1;
	  var warning$1 = warning_1;
	  var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
	  var loggedTypeFailures = {};
	}

	/**
	 * Assert that the values match with the type specs.
	 * Error messages are memorized and will only be shown once.
	 *
	 * @param {object} typeSpecs Map of name to a ReactPropType
	 * @param {object} values Runtime values that need to be type-checked
	 * @param {string} location e.g. "prop", "context", "child context"
	 * @param {string} componentName Name of the component for error messages.
	 * @param {?Function} getStack Returns the component stack.
	 * @private
	 */
	function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
	  {
	    for (var typeSpecName in typeSpecs) {
	      if (typeSpecs.hasOwnProperty(typeSpecName)) {
	        var error;
	        // Prop type validation may throw. In case they do, we don't want to
	        // fail the render phase where it didn't fail before. So we log it.
	        // After these have been cleaned up, we'll let them throw.
	        try {
	          // This is intentionally an invariant that gets caught. It's the same
	          // behavior as without this statement except with a better message.
	          invariant$1(typeof typeSpecs[typeSpecName] === 'function', '%s: %s type `%s` is invalid; it must be a function, usually from ' + 'the `prop-types` package, but received `%s`.', componentName || 'React class', location, typeSpecName, typeof typeSpecs[typeSpecName]);
	          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
	        } catch (ex) {
	          error = ex;
	        }
	        warning$1(!error || error instanceof Error, '%s: type specification of %s `%s` is invalid; the type checker ' + 'function must return `null` or an `Error` but returned a %s. ' + 'You may have forgotten to pass an argument to the type checker ' + 'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' + 'shape all require an argument).', componentName || 'React class', location, typeSpecName, typeof error);
	        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
	          // Only monitor this failure once because there tends to be a lot of the
	          // same error.
	          loggedTypeFailures[error.message] = true;

	          var stack = getStack ? getStack() : '';

	          warning$1(false, 'Failed %s type: %s%s', location, error.message, stack != null ? stack : '');
	        }
	      }
	    }
	  }
	}

	var checkPropTypes_1 = checkPropTypes;

	var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
	  /* global Symbol */
	  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
	  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

	  /**
	   * Returns the iterator method function contained on the iterable object.
	   *
	   * Be sure to invoke the function with the iterable as context:
	   *
	   *     var iteratorFn = getIteratorFn(myIterable);
	   *     if (iteratorFn) {
	   *       var iterator = iteratorFn.call(myIterable);
	   *       ...
	   *     }
	   *
	   * @param {?object} maybeIterable
	   * @return {?function}
	   */
	  function getIteratorFn(maybeIterable) {
	    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
	    if (typeof iteratorFn === 'function') {
	      return iteratorFn;
	    }
	  }

	  /**
	   * Collection of methods that allow declaration and validation of props that are
	   * supplied to React components. Example usage:
	   *
	   *   var Props = require('ReactPropTypes');
	   *   var MyArticle = React.createClass({
	   *     propTypes: {
	   *       // An optional string prop named "description".
	   *       description: Props.string,
	   *
	   *       // A required enum prop named "category".
	   *       category: Props.oneOf(['News','Photos']).isRequired,
	   *
	   *       // A prop named "dialog" that requires an instance of Dialog.
	   *       dialog: Props.instanceOf(Dialog).isRequired
	   *     },
	   *     render: function() { ... }
	   *   });
	   *
	   * A more formal specification of how these methods are used:
	   *
	   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
	   *   decl := ReactPropTypes.{type}(.isRequired)?
	   *
	   * Each and every declaration produces a function with the same signature. This
	   * allows the creation of custom validation functions. For example:
	   *
	   *  var MyLink = React.createClass({
	   *    propTypes: {
	   *      // An optional string or URI prop named "href".
	   *      href: function(props, propName, componentName) {
	   *        var propValue = props[propName];
	   *        if (propValue != null && typeof propValue !== 'string' &&
	   *            !(propValue instanceof URI)) {
	   *          return new Error(
	   *            'Expected a string or an URI for ' + propName + ' in ' +
	   *            componentName
	   *          );
	   *        }
	   *      }
	   *    },
	   *    render: function() {...}
	   *  });
	   *
	   * @internal
	   */

	  var ANONYMOUS = '<<anonymous>>';

	  // Important!
	  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
	  var ReactPropTypes = {
	    array: createPrimitiveTypeChecker('array'),
	    bool: createPrimitiveTypeChecker('boolean'),
	    func: createPrimitiveTypeChecker('function'),
	    number: createPrimitiveTypeChecker('number'),
	    object: createPrimitiveTypeChecker('object'),
	    string: createPrimitiveTypeChecker('string'),
	    symbol: createPrimitiveTypeChecker('symbol'),

	    any: createAnyTypeChecker(),
	    arrayOf: createArrayOfTypeChecker,
	    element: createElementTypeChecker(),
	    instanceOf: createInstanceTypeChecker,
	    node: createNodeChecker(),
	    objectOf: createObjectOfTypeChecker,
	    oneOf: createEnumTypeChecker,
	    oneOfType: createUnionTypeChecker,
	    shape: createShapeTypeChecker,
	    exact: createStrictShapeTypeChecker,
	  };

	  /**
	   * inlined Object.is polyfill to avoid requiring consumers ship their own
	   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
	   */
	  /*eslint-disable no-self-compare*/
	  function is(x, y) {
	    // SameValue algorithm
	    if (x === y) {
	      // Steps 1-5, 7-10
	      // Steps 6.b-6.e: +0 != -0
	      return x !== 0 || 1 / x === 1 / y;
	    } else {
	      // Step 6.a: NaN == NaN
	      return x !== x && y !== y;
	    }
	  }
	  /*eslint-enable no-self-compare*/

	  /**
	   * We use an Error-like object for backward compatibility as people may call
	   * PropTypes directly and inspect their output. However, we don't use real
	   * Errors anymore. We don't inspect their stack anyway, and creating them
	   * is prohibitively expensive if they are created too often, such as what
	   * happens in oneOfType() for any type before the one that matched.
	   */
	  function PropTypeError(message) {
	    this.message = message;
	    this.stack = '';
	  }
	  // Make `instanceof Error` still work for returned errors.
	  PropTypeError.prototype = Error.prototype;

	  function createChainableTypeChecker(validate) {
	    {
	      var manualPropTypeCallCache = {};
	      var manualPropTypeWarningCount = 0;
	    }
	    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
	      componentName = componentName || ANONYMOUS;
	      propFullName = propFullName || propName;

	      if (secret !== ReactPropTypesSecret_1) {
	        if (throwOnDirectAccess) {
	          // New behavior only for users of `prop-types` package
	          invariant_1(
	            false,
	            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
	            'Use `PropTypes.checkPropTypes()` to call them. ' +
	            'Read more at http://fb.me/use-check-prop-types'
	          );
	        } else if ("development" !== 'production' && typeof console !== 'undefined') {
	          // Old behavior for people using React.PropTypes
	          var cacheKey = componentName + ':' + propName;
	          if (
	            !manualPropTypeCallCache[cacheKey] &&
	            // Avoid spamming the console because they are often not actionable except for lib authors
	            manualPropTypeWarningCount < 3
	          ) {
	            warning_1(
	              false,
	              'You are manually calling a React.PropTypes validation ' +
	              'function for the `%s` prop on `%s`. This is deprecated ' +
	              'and will throw in the standalone `prop-types` package. ' +
	              'You may be seeing this warning due to a third-party PropTypes ' +
	              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.',
	              propFullName,
	              componentName
	            );
	            manualPropTypeCallCache[cacheKey] = true;
	            manualPropTypeWarningCount++;
	          }
	        }
	      }
	      if (props[propName] == null) {
	        if (isRequired) {
	          if (props[propName] === null) {
	            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
	          }
	          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
	        }
	        return null;
	      } else {
	        return validate(props, propName, componentName, location, propFullName);
	      }
	    }

	    var chainedCheckType = checkType.bind(null, false);
	    chainedCheckType.isRequired = checkType.bind(null, true);

	    return chainedCheckType;
	  }

	  function createPrimitiveTypeChecker(expectedType) {
	    function validate(props, propName, componentName, location, propFullName, secret) {
	      var propValue = props[propName];
	      var propType = getPropType(propValue);
	      if (propType !== expectedType) {
	        // `propValue` being instance of, say, date/regexp, pass the 'object'
	        // check, but we can offer a more precise error message here rather than
	        // 'of type `object`'.
	        var preciseType = getPreciseType(propValue);

	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createAnyTypeChecker() {
	    return createChainableTypeChecker(emptyFunction_1.thatReturnsNull);
	  }

	  function createArrayOfTypeChecker(typeChecker) {
	    function validate(props, propName, componentName, location, propFullName) {
	      if (typeof typeChecker !== 'function') {
	        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
	      }
	      var propValue = props[propName];
	      if (!Array.isArray(propValue)) {
	        var propType = getPropType(propValue);
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
	      }
	      for (var i = 0; i < propValue.length; i++) {
	        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
	        if (error instanceof Error) {
	          return error;
	        }
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createElementTypeChecker() {
	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      if (!isValidElement(propValue)) {
	        var propType = getPropType(propValue);
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createInstanceTypeChecker(expectedClass) {
	    function validate(props, propName, componentName, location, propFullName) {
	      if (!(props[propName] instanceof expectedClass)) {
	        var expectedClassName = expectedClass.name || ANONYMOUS;
	        var actualClassName = getClassName(props[propName]);
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createEnumTypeChecker(expectedValues) {
	    if (!Array.isArray(expectedValues)) {
	      warning_1(false, 'Invalid argument supplied to oneOf, expected an instance of array.');
	      return emptyFunction_1.thatReturnsNull;
	    }

	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      for (var i = 0; i < expectedValues.length; i++) {
	        if (is(propValue, expectedValues[i])) {
	          return null;
	        }
	      }

	      var valuesString = JSON.stringify(expectedValues);
	      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + propValue + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createObjectOfTypeChecker(typeChecker) {
	    function validate(props, propName, componentName, location, propFullName) {
	      if (typeof typeChecker !== 'function') {
	        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
	      }
	      var propValue = props[propName];
	      var propType = getPropType(propValue);
	      if (propType !== 'object') {
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
	      }
	      for (var key in propValue) {
	        if (propValue.hasOwnProperty(key)) {
	          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
	          if (error instanceof Error) {
	            return error;
	          }
	        }
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createUnionTypeChecker(arrayOfTypeCheckers) {
	    if (!Array.isArray(arrayOfTypeCheckers)) {
	      warning_1(false, 'Invalid argument supplied to oneOfType, expected an instance of array.');
	      return emptyFunction_1.thatReturnsNull;
	    }

	    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
	      var checker = arrayOfTypeCheckers[i];
	      if (typeof checker !== 'function') {
	        warning_1(
	          false,
	          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
	          'received %s at index %s.',
	          getPostfixForTypeWarning(checker),
	          i
	        );
	        return emptyFunction_1.thatReturnsNull;
	      }
	    }

	    function validate(props, propName, componentName, location, propFullName) {
	      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
	        var checker = arrayOfTypeCheckers[i];
	        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
	          return null;
	        }
	      }

	      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createNodeChecker() {
	    function validate(props, propName, componentName, location, propFullName) {
	      if (!isNode(props[propName])) {
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createShapeTypeChecker(shapeTypes) {
	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      var propType = getPropType(propValue);
	      if (propType !== 'object') {
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
	      }
	      for (var key in shapeTypes) {
	        var checker = shapeTypes[key];
	        if (!checker) {
	          continue;
	        }
	        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
	        if (error) {
	          return error;
	        }
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createStrictShapeTypeChecker(shapeTypes) {
	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      var propType = getPropType(propValue);
	      if (propType !== 'object') {
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
	      }
	      // We need to check all keys in case some are required but missing from
	      // props.
	      var allKeys = objectAssign({}, props[propName], shapeTypes);
	      for (var key in allKeys) {
	        var checker = shapeTypes[key];
	        if (!checker) {
	          return new PropTypeError(
	            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
	            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
	            '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
	          );
	        }
	        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
	        if (error) {
	          return error;
	        }
	      }
	      return null;
	    }

	    return createChainableTypeChecker(validate);
	  }

	  function isNode(propValue) {
	    switch (typeof propValue) {
	      case 'number':
	      case 'string':
	      case 'undefined':
	        return true;
	      case 'boolean':
	        return !propValue;
	      case 'object':
	        if (Array.isArray(propValue)) {
	          return propValue.every(isNode);
	        }
	        if (propValue === null || isValidElement(propValue)) {
	          return true;
	        }

	        var iteratorFn = getIteratorFn(propValue);
	        if (iteratorFn) {
	          var iterator = iteratorFn.call(propValue);
	          var step;
	          if (iteratorFn !== propValue.entries) {
	            while (!(step = iterator.next()).done) {
	              if (!isNode(step.value)) {
	                return false;
	              }
	            }
	          } else {
	            // Iterator will provide entry [k,v] tuples rather than values.
	            while (!(step = iterator.next()).done) {
	              var entry = step.value;
	              if (entry) {
	                if (!isNode(entry[1])) {
	                  return false;
	                }
	              }
	            }
	          }
	        } else {
	          return false;
	        }

	        return true;
	      default:
	        return false;
	    }
	  }

	  function isSymbol(propType, propValue) {
	    // Native Symbol.
	    if (propType === 'symbol') {
	      return true;
	    }

	    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
	    if (propValue['@@toStringTag'] === 'Symbol') {
	      return true;
	    }

	    // Fallback for non-spec compliant Symbols which are polyfilled.
	    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
	      return true;
	    }

	    return false;
	  }

	  // Equivalent of `typeof` but with special handling for array and regexp.
	  function getPropType(propValue) {
	    var propType = typeof propValue;
	    if (Array.isArray(propValue)) {
	      return 'array';
	    }
	    if (propValue instanceof RegExp) {
	      // Old webkits (at least until Android 4.0) return 'function' rather than
	      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
	      // passes PropTypes.object.
	      return 'object';
	    }
	    if (isSymbol(propType, propValue)) {
	      return 'symbol';
	    }
	    return propType;
	  }

	  // This handles more types than `getPropType`. Only used for error messages.
	  // See `createPrimitiveTypeChecker`.
	  function getPreciseType(propValue) {
	    if (typeof propValue === 'undefined' || propValue === null) {
	      return '' + propValue;
	    }
	    var propType = getPropType(propValue);
	    if (propType === 'object') {
	      if (propValue instanceof Date) {
	        return 'date';
	      } else if (propValue instanceof RegExp) {
	        return 'regexp';
	      }
	    }
	    return propType;
	  }

	  // Returns a string that is postfixed to a warning about an invalid type.
	  // For example, "undefined" or "of type array"
	  function getPostfixForTypeWarning(value) {
	    var type = getPreciseType(value);
	    switch (type) {
	      case 'array':
	      case 'object':
	        return 'an ' + type;
	      case 'boolean':
	      case 'date':
	      case 'regexp':
	        return 'a ' + type;
	      default:
	        return type;
	    }
	  }

	  // Returns class name of the object, if any.
	  function getClassName(propValue) {
	    if (!propValue.constructor || !propValue.constructor.name) {
	      return ANONYMOUS;
	    }
	    return propValue.constructor.name;
	  }

	  ReactPropTypes.checkPropTypes = checkPropTypes_1;
	  ReactPropTypes.PropTypes = ReactPropTypes;

	  return ReactPropTypes;
	};

	var propTypes = createCommonjsModule(function (module) {
	/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */

	{
	  var REACT_ELEMENT_TYPE = (typeof Symbol === 'function' &&
	    Symbol.for &&
	    Symbol.for('react.element')) ||
	    0xeac7;

	  var isValidElement = function(object) {
	    return typeof object === 'object' &&
	      object !== null &&
	      object.$$typeof === REACT_ELEMENT_TYPE;
	  };

	  // By explicitly using `prop-types` you are opting into new development behavior.
	  // http://fb.me/prop-types-in-prod
	  var throwOnDirectAccess = true;
	  module.exports = factoryWithTypeCheckers(isValidElement, throwOnDirectAccess);
	}
	});

	var Button = function (_Component) {
	  inherits(Button, _Component);

	  function Button() {
	    var _temp, _this, _ret;

	    classCallCheck(this, Button);

	    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	      args[_key] = arguments[_key];
	    }

	    return _ret = (_temp = (_this = possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.getRippleRef = function (component) {
	      _this.rippleComponent = component;
	    }, _this.onClick = function (e) {
	      var onClick = _this.props.onClick;


	      if (_this.rippleComponent) {
	        _this.rippleComponent.onClick(e);
	      }

	      if (onClick) {
	        onClick();
	      }
	    }, _temp), possibleConstructorReturn(_this, _ret);
	  }

	  Button.prototype.render = function render() {
	    var _props = this.props,
	        children = _props.children,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        _props$raised = _props.raised,
	        raised = _props$raised === undefined ? false : _props$raised,
	        _props$flat = _props.flat,
	        flat = _props$flat === undefined ? false : _props$flat,
	        _props$stroked = _props.stroked,
	        stroked = _props$stroked === undefined ? false : _props$stroked,
	        _props$compact = _props.compact,
	        compact = _props$compact === undefined ? flat : _props$compact,
	        _props$ripple = _props.ripple,
	        ripple = _props$ripple === undefined ? true : _props$ripple,
	        otherProps = objectWithoutProperties(_props, ['children', 'className', 'raised', 'flat', 'stroked', 'compact', 'ripple']);


	    var componentClassNames = classnames('mt-button', className, {
	      'mt-button-raised': raised,
	      'mt-button-flat': flat,
	      'mt-button-stroked': stroked,
	      'mt-button-compact': compact
	    });

	    return React__default.createElement(
	      'button',
	      _extends({}, otherProps, {
	        className: componentClassNames,
	        onClick: this.onClick }),
	      ripple && React__default.createElement(Ripple, { ref: this.getRippleRef }),
	      children
	    );
	  };

	  return Button;
	}(React.Component);

	Button.propTypes = {
	  className: propTypes.string,
	  raised: propTypes.bool,
	  flat: propTypes.bool,
	  stroked: propTypes.bool,
	  compact: propTypes.bool,
	  ripple: propTypes.bool,
	  onClick: propTypes.func
	};

	var Checkbox = function (_Component) {
	  inherits(Checkbox, _Component);

	  function Checkbox() {
	    classCallCheck(this, Checkbox);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Checkbox.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        style = _props.style,
	        props = objectWithoutProperties(_props, ['className', 'style']);

	    return React__default.createElement(
	      'div',
	      { className: 'mt-checkbox ' + className, style: style },
	      React__default.createElement('input', _extends({ className: 'mt-checkbox_input', type: 'checkbox' }, props)),
	      React__default.createElement('div', { className: 'mt-checkbox_checkbox' }),
	      React__default.createElement('div', { className: 'mt-checkbox_focus' })
	    );
	  };

	  return Checkbox;
	}(React.Component);

	Checkbox.propTypes = {
	  className: propTypes.string,
	  style: propTypes.object
	};

	var Switch = function (_Component) {
	  inherits(Switch, _Component);

	  function Switch() {
	    classCallCheck(this, Switch);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Switch.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        style = _props.style,
	        props = objectWithoutProperties(_props, ['className', 'style']);

	    return React__default.createElement(
	      'div',
	      _extends({ className: 'mt-switch ' + className }, style),
	      React__default.createElement('input', _extends({ type: 'checkbox', className: 'mt-switch_input' }, props)),
	      React__default.createElement('div', { className: 'mt-switch_switch' }),
	      React__default.createElement('div', { className: 'mt-switch_focus' })
	    );
	  };

	  return Switch;
	}(React.Component);

	Switch.propTypes = {
	  className: propTypes.string,
	  style: propTypes.object
	};

	var Avatar = function (_Component) {
	  inherits(Avatar, _Component);

	  function Avatar() {
	    classCallCheck(this, Avatar);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Avatar.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        image = _props.image,
	        _props$initials = _props.initials,
	        initials = _props$initials === undefined ? '' : _props$initials,
	        props = objectWithoutProperties(_props, ['className', 'image', 'initials']);


	    return React__default.createElement(
	      'div',
	      _extends({ className: 'mt-avatar ' + className }, props),
	      image ? React__default.createElement('img', { className: 'mt-avatar_image', src: image, alt: '' }) : React__default.createElement(
	        'div',
	        { className: 'mt-avatar_initials' },
	        initials
	      )
	    );
	  };

	  return Avatar;
	}(React.Component);

	Avatar.propTypes = {
	  className: propTypes.string,
	  image: propTypes.string,
	  initials: propTypes.string
	};

	var Spinner = function (_Component) {
	  inherits(Spinner, _Component);

	  function Spinner() {
	    classCallCheck(this, Spinner);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Spinner.prototype.render = function render() {
	    var _props = this.props,
	        _props$size = _props.size,
	        size = _props$size === undefined ? 'calc(var(--mt-baseFontSize, 1rem) * 1.5)' : _props$size,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        style = _props.style,
	        props = objectWithoutProperties(_props, ['size', 'className', 'style']);


	    return React__default.createElement(
	      'svg',
	      _extends({
	        className: 'mt-spinner ' + className,
	        style: _extends({
	          width: size,
	          height: size
	        }, style),
	        viewBox: '0 0 66 66',
	        xmlns: 'http://www.w3.org/2000/svg'
	      }, props),
	      React__default.createElement('circle', {
	        className: 'mt-spinner_path',
	        fill: 'none',
	        strokeWidth: '6',
	        strokeLinecap: 'round',
	        cx: '33',
	        cy: '33',
	        r: '30'
	      })
	    );
	  };

	  return Spinner;
	}(React.Component);

	Spinner.propTypes = {
	  size: propTypes.oneOfType([propTypes.number, propTypes.string]),
	  className: propTypes.string
	};

	var InlineSpinner = function (_Component) {
	  inherits(InlineSpinner, _Component);

	  function InlineSpinner() {
	    classCallCheck(this, InlineSpinner);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  InlineSpinner.prototype.render = function render() {
	    var _props = this.props,
	        _props$size = _props.size,
	        size = _props$size === undefined ? 'calc(var(--mt-baseFontSize, 1rem) * 1.125)' : _props$size,
	        style = _props.style,
	        rest = objectWithoutProperties(_props, ['size', 'style']);


	    return React__default.createElement(
	      'svg',
	      _extends({
	        style: _extends({
	          width: size,
	          height: size
	        }, style),
	        viewBox: '0 0 50 40'
	      }, rest),
	      React__default.createElement(
	        'g',
	        { className: 'mt-inlineSpinner_one' },
	        React__default.createElement('circle', { cx: '10', cy: '10', r: '5', className: 'mt-inlineSpinner_circle' })
	      ),
	      React__default.createElement(
	        'g',
	        { className: 'mt-inlineSpinner_three' },
	        React__default.createElement('circle', { cx: '40', cy: '10', r: '5', className: 'mt-inlineSpinner_circle' })
	      ),
	      React__default.createElement(
	        'g',
	        { className: 'mt-inlineSpinner_two' },
	        React__default.createElement('circle', { cx: '25', cy: '10', r: '5', className: 'mt-inlineSpinner_circle' })
	      )
	    );
	  };

	  return InlineSpinner;
	}(React.Component);


	InlineSpinner.propTypes = {
	  size: propTypes.oneOfType([propTypes.number, propTypes.string])
	};

	var Radio = function (_Component) {
	  inherits(Radio, _Component);

	  function Radio() {
	    classCallCheck(this, Radio);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Radio.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        style = _props.style,
	        props = objectWithoutProperties(_props, ['className', 'style']);


	    return React__default.createElement(
	      'div',
	      { className: 'mt-radio ' + className, style: style },
	      React__default.createElement('input', _extends({ className: 'mt-radio_input', type: 'radio' }, props)),
	      React__default.createElement('div', { className: 'mt-radio_radio' }),
	      React__default.createElement('div', { className: 'mt-radio_focus' })
	    );
	  };

	  return Radio;
	}(React.Component);

	Radio.propTypes = {
	  className: propTypes.string,
	  style: propTypes.object
	};

	var Dialog = function (_Component) {
	  inherits(Dialog, _Component);

	  function Dialog() {
	    classCallCheck(this, Dialog);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Dialog.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        props = objectWithoutProperties(_props, ['className']);

	    return React__default.createElement('div', _extends({ className: 'mt-dialog ' + className }, props));
	  };

	  return Dialog;
	}(React.Component);

	Dialog.Title = function (_ref) {
	  var _ref$className = _ref.className,
	      className = _ref$className === undefined ? '' : _ref$className,
	      props = objectWithoutProperties(_ref, ['className']);
	  return React__default.createElement('div', _extends({ className: 'mt-dialog_title ' + className }, props));
	};

	Dialog.Body = function (_ref2) {
	  var _ref2$className = _ref2.className,
	      className = _ref2$className === undefined ? '' : _ref2$className,
	      props = objectWithoutProperties(_ref2, ['className']);
	  return React__default.createElement('div', _extends({ className: 'mt-dialog_content ' + className }, props));
	};

	Dialog.Actions = function (_ref3) {
	  var _ref3$className = _ref3.className,
	      className = _ref3$className === undefined ? '' : _ref3$className,
	      props = objectWithoutProperties(_ref3, ['className']);
	  return React__default.createElement('div', _extends({ className: 'mt-dialog_actions ' + className }, props));
	};

	Dialog.propTypes = {
	  className: propTypes.string
	};

	function clamp(min, val, max) {
	  return Math.min(Math.max(min, val), max);
	}

	var Elevation = function (_Component) {
	  inherits(Elevation, _Component);

	  function Elevation() {
	    classCallCheck(this, Elevation);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Elevation.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        _props$depth = _props.depth,
	        depth = _props$depth === undefined ? 1 : _props$depth,
	        props = objectWithoutProperties(_props, ['className', 'depth']);


	    var depthToUse = Number.isNaN(depth) ? 1 : depth;
	    var clampedDepth = clamp(0, depthToUse, 5);

	    return React__default.createElement('div', _extends({
	      className: 'mt-elevation mt-elevation-' + clampedDepth + ' ' + className
	    }, props));
	  };

	  return Elevation;
	}(React.Component);

	Elevation.propTypes = {
	  className: propTypes.string,
	  depth: propTypes.oneOf([0, 1, 2, 3, 4, 5])
	};

	var InputChip = function (_Component) {
	  inherits(InputChip, _Component);

	  function InputChip() {
	    var _temp, _this, _ret;

	    classCallCheck(this, InputChip);

	    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	      args[_key] = arguments[_key];
	    }

	    return _ret = (_temp = (_this = possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.getRippleRef = function (component) {
	      _this.rippleComponent = component;
	    }, _this.onClose = function (e) {
	      var onClose = _this.props.onClose;

	      e.stopPropagation();
	      onClose(e);
	    }, _this.onClick = function (e) {
	      var onClick = _this.props.onClick;


	      if (_this.rippleComponent) {
	        _this.rippleComponent.onClick(e);
	      }

	      if (onClick) {
	        onClick();
	      }
	    }, _temp), possibleConstructorReturn(_this, _ret);
	  }

	  InputChip.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        onClose = _props.onClose,
	        icon = _props.icon,
	        _props$ripple = _props.ripple,
	        ripple = _props$ripple === undefined ? true : _props$ripple,
	        children = _props.children,
	        props = objectWithoutProperties(_props, ['className', 'onClose', 'icon', 'ripple', 'children']);

	    return React__default.createElement(
	      'div',
	      {
	        className: 'mt-chip ' + (props.onClick ? '' : 'mt-chip-notClickable') + ' ' + className,
	        onClick: this.onClick },
	      icon && React__default.cloneElement(icon, {
	        className: 'mt-chip_icon ' + icon.props.className
	      }),
	      React__default.createElement(
	        'div',
	        { className: 'mt-chip_chip' },
	        children
	      ),
	      onClose && React__default.createElement(
	        'svg',
	        {
	          xmlns: 'http://www.w3.org/2000/svg',
	          className: 'mt-chip_closeIcon',
	          onClick: this.onClose,
	          width: '1em',
	          height: '1em',
	          viewBox: '0 0 48 48' },
	        React__default.createElement('path', { d: 'M24 4C12.95 4 4 12.95 4 24s8.95 20 20 20 20-8.95 20-20S35.05 4 24 4zm10 27.17L31.17 34 24 26.83 16.83 34 14 31.17 21.17 24 14 16.83 16.83 14 24 21.17 31.17 14 34 16.83 26.83 24 34 31.17z' })
	      ),
	      ripple && props.onClick && React__default.createElement(Ripple, { ref: this.getRippleRef })
	    );
	  };

	  return InputChip;
	}(React.Component);


	InputChip.propTypes = {
	  className: propTypes.string,
	  icon: propTypes.element,
	  ripple: propTypes.bool,
	  onClose: propTypes.func,
	  onClick: propTypes.func
	};

	var ActionChip = function (_Component) {
	  inherits(ActionChip, _Component);

	  function ActionChip() {
	    var _temp, _this, _ret;

	    classCallCheck(this, ActionChip);

	    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	      args[_key] = arguments[_key];
	    }

	    return _ret = (_temp = (_this = possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.getRippleRef = function (component) {
	      _this.rippleComponent = component;
	    }, _this.onClick = function (e) {
	      var onClick = _this.props.onClick;


	      if (_this.rippleComponent) {
	        _this.rippleComponent.onClick(e);
	      }

	      if (onClick) {
	        onClick();
	      }
	    }, _temp), possibleConstructorReturn(_this, _ret);
	  }

	  ActionChip.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        _props$ripple = _props.ripple,
	        ripple = _props$ripple === undefined ? true : _props$ripple,
	        children = _props.children,
	        props = objectWithoutProperties(_props, ['className', 'ripple', 'children']);


	    return React__default.createElement(
	      'button',
	      _extends({
	        className: 'mt-chip ' + (props.onClick ? '' : 'mt-chip-notClickable') + ' ' + className
	      }, props, {
	        onClick: this.onClick }),
	      React__default.createElement(
	        'div',
	        { className: 'mt-chip_chip' },
	        children
	      ),
	      ripple && props.onClick && React__default.createElement(Ripple, { ref: this.getRippleRef })
	    );
	  };

	  return ActionChip;
	}(React.Component);

	ActionChip.propTypes = {
	  className: propTypes.string,
	  ripple: propTypes.bool,
	  onClick: propTypes.func
	};

	var ChoiceChip = function (_Component) {
	  inherits(ChoiceChip, _Component);

	  function ChoiceChip() {
	    var _temp, _this, _ret;

	    classCallCheck(this, ChoiceChip);

	    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	      args[_key] = arguments[_key];
	    }

	    return _ret = (_temp = (_this = possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.getRippleRef = function (component) {
	      _this.rippleComponent = component;
	    }, _this.onClick = function (e) {
	      var onClick = _this.props.onClick;


	      if (_this.rippleComponent) {
	        _this.rippleComponent.onClick(e);
	      }

	      if (onClick) {
	        onClick();
	      }
	    }, _temp), possibleConstructorReturn(_this, _ret);
	  }

	  ChoiceChip.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        _props$ripple = _props.ripple,
	        ripple = _props$ripple === undefined ? true : _props$ripple,
	        children = _props.children,
	        props = objectWithoutProperties(_props, ['className', 'ripple', 'children']);


	    return React__default.createElement(
	      'div',
	      { className: 'mt-chip ' + className, onClick: this.onClick },
	      React__default.createElement('input', _extends({ type: 'radio', className: 'mt-chip_input' }, props)),
	      React__default.createElement(
	        'div',
	        { className: 'mt-chip_chip' },
	        children
	      ),
	      ripple && React__default.createElement(Ripple, { ref: this.getRippleRef })
	    );
	  };

	  return ChoiceChip;
	}(React.Component);

	ChoiceChip.propTypes = {
	  className: propTypes.string,
	  ripple: propTypes.bool,
	  onClick: propTypes.func
	};

	var FilterChip = function (_Component) {
	  inherits(FilterChip, _Component);

	  function FilterChip() {
	    var _temp, _this, _ret;

	    classCallCheck(this, FilterChip);

	    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	      args[_key] = arguments[_key];
	    }

	    return _ret = (_temp = (_this = possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.getRippleRef = function (component) {
	      _this.rippleComponent = component;
	    }, _this.onClick = function (e) {
	      var onClick = _this.props.onClick;


	      if (_this.rippleComponent) {
	        _this.rippleComponent.onClick(e);
	      }

	      if (onClick) {
	        onClick();
	      }
	    }, _temp), possibleConstructorReturn(_this, _ret);
	  }

	  FilterChip.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        _props$ripple = _props.ripple,
	        ripple = _props$ripple === undefined ? true : _props$ripple,
	        icon = _props.icon,
	        children = _props.children,
	        props = objectWithoutProperties(_props, ['className', 'ripple', 'icon', 'children']);


	    return React__default.createElement(
	      'div',
	      { className: 'mt-chip ' + className, onClick: this.onClick },
	      React__default.createElement('input', _extends({ type: 'checkbox', className: 'mt-chip_input' }, props)),
	      icon && React__default.cloneElement(icon, {
	        className: 'mt-chip_icon ' + icon.props.className
	      }),
	      React__default.createElement(
	        'svg',
	        { className: 'mt-chip_checkmark', viewBox: '-2 -3 30 30' },
	        React__default.createElement('path', {
	          className: 'mt-chip_checkmarkPath',
	          fill: 'none',
	          stroke: 'black',
	          d: 'M1.73,12.91 8.1,19.28 22.79,4.59'
	        })
	      ),
	      React__default.createElement(
	        'div',
	        { className: 'mt-chip_chip' },
	        children
	      ),
	      ripple && React__default.createElement(Ripple, { ref: this.getRippleRef })
	    );
	  };

	  return FilterChip;
	}(React.Component);

	FilterChip.propTypes = {
	  className: propTypes.string,
	  ripple: propTypes.bool,
	  icon: propTypes.element,
	  onClick: propTypes.func
	};

	var Menu = function (_Component) {
	  inherits(Menu, _Component);

	  function Menu() {
	    classCallCheck(this, Menu);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Menu.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        props = objectWithoutProperties(_props, ['className']);

	    return React__default.createElement(
	      Elevation,
	      { depth: 1 },
	      React__default.createElement('ul', _extends({ className: 'mt-menu ' + className }, props))
	    );
	  };

	  return Menu;
	}(React.Component);


	Menu.propTypes = {
	  className: propTypes.string
	};

	var Item = function (_Component2) {
	  inherits(Item, _Component2);

	  function Item() {
	    var _temp, _this2, _ret;

	    classCallCheck(this, Item);

	    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	      args[_key] = arguments[_key];
	    }

	    return _ret = (_temp = (_this2 = possibleConstructorReturn(this, _Component2.call.apply(_Component2, [this].concat(args))), _this2), _this2.getRippleRef = function (component) {
	      _this2.rippleComponent = component;
	    }, _this2.onClick = function (e) {
	      var onClick = _this2.props.onClick;


	      if (_this2.rippleComponent) {
	        _this2.rippleComponent.onClick(e);
	      }

	      if (onClick) {
	        onClick();
	      }
	    }, _temp), possibleConstructorReturn(_this2, _ret);
	  }

	  Item.prototype.render = function render() {
	    var _props2 = this.props,
	        _props2$className = _props2.className,
	        className = _props2$className === undefined ? '' : _props2$className,
	        _props2$separator = _props2.separator,
	        separator = _props2$separator === undefined ? false : _props2$separator,
	        _props2$selected = _props2.selected,
	        selected = _props2$selected === undefined ? false : _props2$selected,
	        _props2$ripple = _props2.ripple,
	        ripple = _props2$ripple === undefined ? true : _props2$ripple,
	        children = _props2.children,
	        props = objectWithoutProperties(_props2, ['className', 'separator', 'selected', 'ripple', 'children']);

	    return React__default.createElement(
	      'div',
	      _extends({
	        className: 'mt-menu_item ' + (separator ? 'mt-menu_item-separator' : '') + ' ' + (selected ? 'mt-menu_item-selected' : '') + ' ' + className
	      }, props, {
	        onClick: this.onClick }),
	      children,
	      ripple && React__default.createElement(Ripple, { ref: this.getRippleRef })
	    );
	  };

	  return Item;
	}(React.Component);

	Item.propTypes = {
	  className: propTypes.string,
	  separator: propTypes.bool,
	  selected: propTypes.bool,
	  ripple: propTypes.bool
	};

	Menu.Item = Item;

	var Snackbar = function (_Component) {
	  inherits(Snackbar, _Component);

	  function Snackbar() {
	    classCallCheck(this, Snackbar);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Snackbar.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        props = objectWithoutProperties(_props, ['className']);

	    return React__default.createElement('div', _extends({ className: 'mt-snackbar ' + className }, props));
	  };

	  return Snackbar;
	}(React.Component);


	Snackbar.propTypes = {
	  className: propTypes.string
	};

	var TableContext = React__default.createContext({ columnProps: {} });

	var columnInheritedProps = ['width', 'rightBorder'];

	function areEqualShallow(a, b) {
	  for (var key in a) {
	    if (!(key in b) || a[key] !== b[key]) {
	      return false;
	    }
	  }
	  for (var _key in b) {
	    if (!(_key in a) || a[_key] !== b[_key]) {
	      return false;
	    }
	  }
	  return true;
	}

	var Table = function (_Component) {
	  inherits(Table, _Component);

	  function Table() {
	    var _temp, _this, _ret;

	    classCallCheck(this, Table);

	    for (var _len = arguments.length, args = Array(_len), _key2 = 0; _key2 < _len; _key2++) {
	      args[_key2] = arguments[_key2];
	    }

	    return _ret = (_temp = (_this = possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.setColumnsProps = function (map) {
	      _this.setState(function (state) {
	        return {
	          context: _extends({}, state.context, {
	            columnProps: map
	          })
	        };
	      });
	    }, _this.state = {
	      context: {
	        columnProps: {},
	        setColumnsProps: _this.setColumnsProps
	      }
	    }, _temp), possibleConstructorReturn(_this, _ret);
	  }

	  Table.prototype.render = function render() {
	    var _props = this.props,
	        children = _props.children,
	        _props$loading = _props.loading,
	        loading = _props$loading === undefined ? false : _props$loading,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        props = objectWithoutProperties(_props, ['children', 'loading', 'className']);

	    return React__default.createElement(
	      TableContext.Provider,
	      { value: this.state.context },
	      React__default.createElement(
	        'div',
	        _extends({
	          className: 'mt-table ' + (loading ? 'mt-table-loading' : '') + ' ' + className,
	          role: 'table'
	        }, props),
	        children
	      )
	    );
	  };

	  return Table;
	}(React.Component);

	var TableHead = function (_Component2) {
	  inherits(TableHead, _Component2);

	  function TableHead() {
	    classCallCheck(this, TableHead);
	    return possibleConstructorReturn(this, _Component2.apply(this, arguments));
	  }

	  TableHead.prototype.render = function render() {
	    var _props2 = this.props,
	        children = _props2.children,
	        _props2$className = _props2.className,
	        className = _props2$className === undefined ? '' : _props2$className,
	        props = objectWithoutProperties(_props2, ['children', 'className']);

	    return React__default.createElement(
	      'div',
	      _extends({
	        className: 'mt-table_header ' + className,
	        role: 'rowgroup'
	      }, props),
	      children
	    );
	  };

	  return TableHead;
	}(React.Component);

	var TableHeadRow = function (_Component3) {
	  inherits(TableHeadRow, _Component3);

	  function TableHeadRow() {
	    classCallCheck(this, TableHeadRow);
	    return possibleConstructorReturn(this, _Component3.apply(this, arguments));
	  }

	  TableHeadRow.prototype.render = function render() {
	    var _props3 = this.props,
	        children = _props3.children,
	        _props3$className = _props3.className,
	        className = _props3$className === undefined ? '' : _props3$className,
	        columnProps = _props3.columnProps,
	        setColumnsProps = _props3.setColumnsProps,
	        props = objectWithoutProperties(_props3, ['children', 'className', 'columnProps', 'setColumnsProps']);

	    return React__default.createElement(
	      'div',
	      _extends({
	        className: 'mt-table_row mt-table_headerRow ' + className,
	        role: 'row'
	      }, props),
	      children
	    );
	  };

	  TableHeadRow.prototype.componentDidMount = function componentDidMount() {
	    var _props4 = this.props,
	        children = _props4.children,
	        setColumnsProps = _props4.setColumnsProps;

	    var map = {};
	    React__default.Children.forEach(children, function (child, index) {
	      Object.keys(child.props).forEach(function (propName) {
	        if (columnInheritedProps.includes(propName)) {
	          map[index] = map[index] || {};
	          map[index][propName] = child.props[propName];
	        }
	      });
	    });
	    setColumnsProps(map);
	  };

	  TableHeadRow.prototype.componentDidUpdate = function componentDidUpdate() {
	    var _props5 = this.props,
	        children = _props5.children,
	        setColumnsProps = _props5.setColumnsProps,
	        columnProps = _props5.columnProps;

	    var map = {};
	    React__default.Children.forEach(children, function (child, index) {
	      Object.keys(child.props).forEach(function (propName) {
	        if (columnInheritedProps.includes(propName)) {
	          map[index] = map[index] || {};
	          map[index][propName] = child.props[propName];
	        }
	      });
	    });

	    //Object is empty
	    if (Object.keys(map).length === 0 && map.constructor === Object) {
	      return;
	    }

	    for (var prop in map) {
	      if (map.hasOwnProperty(prop)) {
	        if (!areEqualShallow(map, columnProps)) return;
	      }
	    }

	    setColumnsProps(map);
	  };

	  return TableHeadRow;
	}(React.Component);

	var WrappedTableHeadRow = function WrappedTableHeadRow(props) {
	  return React__default.createElement(
	    TableContext.Consumer,
	    null,
	    function (ctxProps) {
	      return React__default.createElement(TableHeadRow, _extends({}, props, ctxProps));
	    }
	  );
	};

	var TableHeadCell = function (_Component4) {
	  inherits(TableHeadCell, _Component4);

	  function TableHeadCell() {
	    classCallCheck(this, TableHeadCell);
	    return possibleConstructorReturn(this, _Component4.apply(this, arguments));
	  }

	  TableHeadCell.prototype.render = function render() {
	    var _props6 = this.props,
	        children = _props6.children,
	        _props6$className = _props6.className,
	        className = _props6$className === undefined ? '' : _props6$className,
	        props = objectWithoutProperties(_props6, ['children', 'className']);

	    return React__default.createElement(
	      TableCell,
	      _extends({
	        className: 'mt-table_headerCell ' + className,
	        role: 'columnheader'
	      }, props),
	      React__default.createElement(
	        'div',
	        { className: 'mt-table_headerCellContent' },
	        children
	      )
	    );
	  };

	  return TableHeadCell;
	}(React.Component);

	var TableBody = function (_Component5) {
	  inherits(TableBody, _Component5);

	  function TableBody() {
	    classCallCheck(this, TableBody);
	    return possibleConstructorReturn(this, _Component5.apply(this, arguments));
	  }

	  TableBody.prototype.render = function render() {
	    var _props7 = this.props,
	        _props7$className = _props7.className,
	        className = _props7$className === undefined ? '' : _props7$className,
	        children = _props7.children,
	        props = objectWithoutProperties(_props7, ['className', 'children']);

	    return React__default.createElement(
	      'div',
	      _extends({ className: 'mt-table_body ' + className, role: 'rowgroup' }, props),
	      children
	    );
	  };

	  return TableBody;
	}(React.Component);

	var TableRow = function (_Component6) {
	  inherits(TableRow, _Component6);

	  function TableRow() {
	    classCallCheck(this, TableRow);
	    return possibleConstructorReturn(this, _Component6.apply(this, arguments));
	  }

	  TableRow.prototype.render = function render() {
	    var _props8 = this.props,
	        children = _props8.children,
	        _props8$className = _props8.className,
	        className = _props8$className === undefined ? '' : _props8$className,
	        props = objectWithoutProperties(_props8, ['children', 'className']);

	    var isClickable = typeof props.onClick === 'function';
	    return React__default.createElement(
	      TableContext.Consumer,
	      null,
	      function (_ref) {
	        var columnProps = _ref.columnProps;
	        return React__default.createElement(
	          'div',
	          _extends({
	            className: 'mt-table_row ' + (isClickable ? 'mt-table-clickableElement' : '') + ' ' + className,
	            role: 'row'
	          }, props),
	          React__default.Children.map(children, function (child, index) {
	            var childProps = columnProps && columnProps[index] ? columnProps[index] : {};
	            return React__default.cloneElement(child, _extends({}, childProps));
	          })
	        );
	      }
	    );
	  };

	  return TableRow;
	}(React.Component);

	var TableCell = function (_Component7) {
	  inherits(TableCell, _Component7);

	  function TableCell() {
	    classCallCheck(this, TableCell);
	    return possibleConstructorReturn(this, _Component7.apply(this, arguments));
	  }

	  TableCell.prototype.render = function render() {
	    var _props9 = this.props,
	        children = _props9.children,
	        _props9$className = _props9.className,
	        className = _props9$className === undefined ? '' : _props9$className,
	        _props9$rightBorder = _props9.rightBorder,
	        rightBorder = _props9$rightBorder === undefined ? false : _props9$rightBorder,
	        width = _props9.width,
	        style = _props9.style,
	        props = objectWithoutProperties(_props9, ['children', 'className', 'rightBorder', 'width', 'style']);

	    return React__default.createElement(
	      'div',
	      _extends({
	        className: 'mt-table_cell ' + (rightBorder ? 'mt-table_cell-rightBorder' : '') + ' ' + className,
	        role: 'cell',
	        style: _extends({}, style, {
	          minWidth: width ? width : null,
	          maxWidth: width ? width : null
	        })
	      }, props),
	      children
	    );
	  };

	  return TableCell;
	}(React.Component);

	var TableExpandedRowContent = function (_Component8) {
	  inherits(TableExpandedRowContent, _Component8);

	  function TableExpandedRowContent() {
	    var _temp2, _this8, _ret2;

	    classCallCheck(this, TableExpandedRowContent);

	    for (var _len2 = arguments.length, args = Array(_len2), _key3 = 0; _key3 < _len2; _key3++) {
	      args[_key3] = arguments[_key3];
	    }

	    return _ret2 = (_temp2 = (_this8 = possibleConstructorReturn(this, _Component8.call.apply(_Component8, [this].concat(args))), _this8), _this8.getRef = function (el) {
	      _this8.el = el;
	    }, _temp2), possibleConstructorReturn(_this8, _ret2);
	  }

	  TableExpandedRowContent.prototype.render = function render() {
	    var _props10 = this.props,
	        _props10$className = _props10.className,
	        className = _props10$className === undefined ? '' : _props10$className,
	        children = _props10.children,
	        open = _props10.open,
	        props = objectWithoutProperties(_props10, ['className', 'children', 'open']);

	    return React__default.createElement(
	      'div',
	      _extends({
	        className: 'mt-table_expandedRowContent ' + (open ? 'mt-table_expandedRowContent-open' : '') + className
	      }, props, {
	        ref: this.getRef }),
	      children
	    );
	  };

	  TableExpandedRowContent.prototype.componentDidMount = function componentDidMount() {
	    if (!this.el) return;
	    var bb = this.el.getBoundingClientRect();
	    this.el.style.setProperty('--mt-table-cellHeight', this.props.open ? bb.height + 'px' : 0);
	  };

	  TableExpandedRowContent.prototype.componentDidUpdate = function componentDidUpdate() {
	    var _this9 = this;

	    if (!this.el) return;

	    var initialBb = this.el.getBoundingClientRect();
	    this.el.style.transition = 'none';
	    this.el.style.display = 'block';
	    this.el.style.height = 'auto';
	    var bb = this.el.getBoundingClientRect();
	    this.el.style.height = null;
	    this.el.style.transition = null;
	    this.el.style.display = null;

	    if (!this.props.open) {
	      if (initialBb.height) {
	        this.el.style.setProperty('--mt-table-cellHeight', initialBb.height + 'px');
	        requestAnimationFrame(function () {
	          _this9.el && _this9.el.style.setProperty('--mt-table-cellHeight', 0);
	        });
	        return;
	      }
	      this.el.style.setProperty('--mt-table-cellHeight', 0);
	      return;
	    }

	    requestAnimationFrame(function () {
	      if (!_this9.el) return;
	      _this9.el.style.setProperty('--mt-table-cellHeight', bb.height + 'px');
	      _this9.el.addEventListener('transitionend', function () {
	        _this9.el && _this9.el.style.setProperty('--mt-table-cellHeight', 'auto');
	      }, { once: true });
	    });
	  };

	  return TableExpandedRowContent;
	}(React.Component);

	Table.Head = TableHead;
	Table.HeadRow = WrappedTableHeadRow;
	Table.HeadCell = TableHeadCell;
	Table.Body = TableBody;
	Table.Row = TableRow;
	Table.Cell = TableCell;
	Table.ExpandedRowContent = TableExpandedRowContent;

	var Input = function (_Component) {
	  inherits(Input, _Component);

	  function Input() {
	    classCallCheck(this, Input);
	    return possibleConstructorReturn(this, _Component.apply(this, arguments));
	  }

	  Input.prototype.render = function render() {
	    var _props = this.props,
	        _props$className = _props.className,
	        className = _props$className === undefined ? '' : _props$className,
	        _props$error = _props.error,
	        error = _props$error === undefined ? false : _props$error,
	        props = objectWithoutProperties(_props, ['className', 'error']);


	    return React__default.createElement('input', _extends({
	      className: 'mt-input ' + (error ? 'mt-input-error' : '') + ' ' + className
	    }, props));
	  };

	  return Input;
	}(React.Component);


	Input.propTypes = {
	  className: propTypes.string,
	  error: propTypes.bool
	};

	exports.Avatar = Avatar;
	exports.Button = Button;
	exports.Checkbox = Checkbox;
	exports.Ripple = Ripple;
	exports.Spinner = Spinner;
	exports.InlineSpinner = InlineSpinner;
	exports.Switch = Switch;
	exports.Radio = Radio;
	exports.Dialog = Dialog;
	exports.Elevation = Elevation;
	exports.InputChip = InputChip;
	exports.ActionChip = ActionChip;
	exports.ChoiceChip = ChoiceChip;
	exports.FilterChip = FilterChip;
	exports.Menu = Menu;
	exports.Snackbar = Snackbar;
	exports.Table = Table;
	exports.Input = Input;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
