var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Ripple from '../ripple/ripple';

var ActionChip = function (_Component) {
  _inherits(ActionChip, _Component);

  function ActionChip() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ActionChip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ActionChip.__proto__ || Object.getPrototypeOf(ActionChip)).call.apply(_ref, [this].concat(args))), _this), _this.getRippleRef = function (component) {
      _this.rippleComponent = component;
    }, _this.onClick = function (e) {
      var onClick = _this.props.onClick;


      if (_this.rippleComponent) {
        _this.rippleComponent.onClick(e);
      }

      if (onClick) {
        onClick();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ActionChip, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$className = _props.className,
          className = _props$className === undefined ? '' : _props$className,
          _props$ripple = _props.ripple,
          ripple = _props$ripple === undefined ? true : _props$ripple,
          children = _props.children,
          props = _objectWithoutProperties(_props, ['className', 'ripple', 'children']);

      return React.createElement(
        'button',
        _extends({
          className: 'mt-chip ' + (props.onClick ? '' : 'mt-chip-notClickable') + ' ' + className
        }, props, {
          onClick: this.onClick }),
        React.createElement(
          'div',
          { className: 'mt-chip_chip' },
          children
        ),
        ripple && props.onClick && React.createElement(Ripple, { ref: this.getRippleRef })
      );
    }
  }]);

  return ActionChip;
}(Component);

ActionChip.propTypes = {
  className: PropTypes.string,
  ripple: PropTypes.bool,
  onClick: PropTypes.func
};

export default ActionChip;