var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Ripple from '../ripple/ripple';

var InputChip = function (_Component) {
  _inherits(InputChip, _Component);

  function InputChip() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, InputChip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = InputChip.__proto__ || Object.getPrototypeOf(InputChip)).call.apply(_ref, [this].concat(args))), _this), _this.getRippleRef = function (component) {
      _this.rippleComponent = component;
    }, _this.onClose = function (e) {
      var onClose = _this.props.onClose;

      e.stopPropagation();
      onClose(e);
    }, _this.onClick = function (e) {
      var onClick = _this.props.onClick;


      if (_this.rippleComponent) {
        _this.rippleComponent.onClick(e);
      }

      if (onClick) {
        onClick();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(InputChip, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$className = _props.className,
          className = _props$className === undefined ? '' : _props$className,
          onClose = _props.onClose,
          icon = _props.icon,
          _props$ripple = _props.ripple,
          ripple = _props$ripple === undefined ? true : _props$ripple,
          children = _props.children,
          props = _objectWithoutProperties(_props, ['className', 'onClose', 'icon', 'ripple', 'children']);

      return React.createElement(
        'div',
        {
          className: 'mt-chip ' + (props.onClick ? '' : 'mt-chip-notClickable') + ' ' + className,
          onClick: this.onClick },
        icon && React.cloneElement(icon, {
          className: 'mt-chip_icon ' + icon.props.className
        }),
        React.createElement(
          'div',
          { className: 'mt-chip_chip' },
          children
        ),
        onClose && React.createElement(
          'svg',
          {
            xmlns: 'http://www.w3.org/2000/svg',
            className: 'mt-chip_closeIcon',
            onClick: this.onClose,
            width: '1em',
            height: '1em',
            viewBox: '0 0 48 48' },
          React.createElement('path', { d: 'M24 4C12.95 4 4 12.95 4 24s8.95 20 20 20 20-8.95 20-20S35.05 4 24 4zm10 27.17L31.17 34 24 26.83 16.83 34 14 31.17 21.17 24 14 16.83 16.83 14 24 21.17 31.17 14 34 16.83 26.83 24 34 31.17z' })
        ),
        ripple && props.onClick && React.createElement(Ripple, { ref: this.getRippleRef })
      );
    }
  }]);

  return InputChip;
}(Component);

export default InputChip;


InputChip.propTypes = {
  className: PropTypes.string,
  icon: PropTypes.element,
  ripple: PropTypes.bool,
  onClose: PropTypes.func,
  onClick: PropTypes.func
};