var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

var TableContext = React.createContext({ columnProps: {} });

var columnInheritedProps = ['width', 'rightBorder'];

function areEqualShallow(a, b) {
  for (var key in a) {
    if (!(key in b) || a[key] !== b[key]) {
      return false;
    }
  }
  for (var _key in b) {
    if (!(_key in a) || a[_key] !== b[_key]) {
      return false;
    }
  }
  return true;
}

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Table);

    for (var _len = arguments.length, args = Array(_len), _key2 = 0; _key2 < _len; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Table.__proto__ || Object.getPrototypeOf(Table)).call.apply(_ref, [this].concat(args))), _this), _this.setColumnsProps = function (map) {
      _this.setState(function (state) {
        return {
          context: _extends({}, state.context, {
            columnProps: map
          })
        };
      });
    }, _this.state = {
      context: {
        columnProps: {},
        setColumnsProps: _this.setColumnsProps
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Table, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          _props$loading = _props.loading,
          loading = _props$loading === undefined ? false : _props$loading,
          _props$className = _props.className,
          className = _props$className === undefined ? '' : _props$className,
          props = _objectWithoutProperties(_props, ['children', 'loading', 'className']);

      return React.createElement(
        TableContext.Provider,
        { value: this.state.context },
        React.createElement(
          'div',
          _extends({
            className: 'mt-table ' + (loading ? 'mt-table-loading' : '') + ' ' + className,
            role: 'table'
          }, props),
          children
        )
      );
    }
  }]);

  return Table;
}(Component);

export default Table;

var TableHead = function (_Component2) {
  _inherits(TableHead, _Component2);

  function TableHead() {
    _classCallCheck(this, TableHead);

    return _possibleConstructorReturn(this, (TableHead.__proto__ || Object.getPrototypeOf(TableHead)).apply(this, arguments));
  }

  _createClass(TableHead, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          _props2$className = _props2.className,
          className = _props2$className === undefined ? '' : _props2$className,
          props = _objectWithoutProperties(_props2, ['children', 'className']);

      return React.createElement(
        'div',
        _extends({
          className: 'mt-table_header ' + className,
          role: 'rowgroup'
        }, props),
        children
      );
    }
  }]);

  return TableHead;
}(Component);

var TableHeadRow = function (_Component3) {
  _inherits(TableHeadRow, _Component3);

  function TableHeadRow() {
    _classCallCheck(this, TableHeadRow);

    return _possibleConstructorReturn(this, (TableHeadRow.__proto__ || Object.getPrototypeOf(TableHeadRow)).apply(this, arguments));
  }

  _createClass(TableHeadRow, [{
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          children = _props3.children,
          _props3$className = _props3.className,
          className = _props3$className === undefined ? '' : _props3$className,
          columnProps = _props3.columnProps,
          setColumnsProps = _props3.setColumnsProps,
          props = _objectWithoutProperties(_props3, ['children', 'className', 'columnProps', 'setColumnsProps']);

      return React.createElement(
        'div',
        _extends({
          className: 'mt-table_row mt-table_headerRow ' + className,
          role: 'row'
        }, props),
        children
      );
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props4 = this.props,
          children = _props4.children,
          setColumnsProps = _props4.setColumnsProps;

      var map = {};
      React.Children.forEach(children, function (child, index) {
        Object.keys(child.props).forEach(function (propName) {
          if (columnInheritedProps.includes(propName)) {
            map[index] = map[index] || {};
            map[index][propName] = child.props[propName];
          }
        });
      });
      setColumnsProps(map);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var _props5 = this.props,
          children = _props5.children,
          setColumnsProps = _props5.setColumnsProps,
          columnProps = _props5.columnProps;

      var map = {};
      React.Children.forEach(children, function (child, index) {
        Object.keys(child.props).forEach(function (propName) {
          if (columnInheritedProps.includes(propName)) {
            map[index] = map[index] || {};
            map[index][propName] = child.props[propName];
          }
        });
      });

      //Object is empty
      if (Object.keys(map).length === 0 && map.constructor === Object) {
        return;
      }

      for (var prop in map) {
        if (map.hasOwnProperty(prop)) {
          if (!areEqualShallow(map, columnProps)) return;
        }
      }

      setColumnsProps(map);
    }
  }]);

  return TableHeadRow;
}(Component);

var WrappedTableHeadRow = function WrappedTableHeadRow(props) {
  return React.createElement(
    TableContext.Consumer,
    null,
    function (ctxProps) {
      return React.createElement(TableHeadRow, _extends({}, props, ctxProps));
    }
  );
};

var TableHeadCell = function (_Component4) {
  _inherits(TableHeadCell, _Component4);

  function TableHeadCell() {
    _classCallCheck(this, TableHeadCell);

    return _possibleConstructorReturn(this, (TableHeadCell.__proto__ || Object.getPrototypeOf(TableHeadCell)).apply(this, arguments));
  }

  _createClass(TableHeadCell, [{
    key: 'render',
    value: function render() {
      var _props6 = this.props,
          children = _props6.children,
          _props6$className = _props6.className,
          className = _props6$className === undefined ? '' : _props6$className,
          props = _objectWithoutProperties(_props6, ['children', 'className']);

      return React.createElement(
        TableCell,
        _extends({
          className: 'mt-table_headerCell ' + className,
          role: 'columnheader'
        }, props),
        React.createElement(
          'div',
          { className: 'mt-table_headerCellContent' },
          children
        )
      );
    }
  }]);

  return TableHeadCell;
}(Component);

var TableBody = function (_Component5) {
  _inherits(TableBody, _Component5);

  function TableBody() {
    _classCallCheck(this, TableBody);

    return _possibleConstructorReturn(this, (TableBody.__proto__ || Object.getPrototypeOf(TableBody)).apply(this, arguments));
  }

  _createClass(TableBody, [{
    key: 'render',
    value: function render() {
      var _props7 = this.props,
          _props7$className = _props7.className,
          className = _props7$className === undefined ? '' : _props7$className,
          children = _props7.children,
          props = _objectWithoutProperties(_props7, ['className', 'children']);

      return React.createElement(
        'div',
        _extends({ className: 'mt-table_body ' + className, role: 'rowgroup' }, props),
        children
      );
    }
  }]);

  return TableBody;
}(Component);

var TableRow = function (_Component6) {
  _inherits(TableRow, _Component6);

  function TableRow() {
    _classCallCheck(this, TableRow);

    return _possibleConstructorReturn(this, (TableRow.__proto__ || Object.getPrototypeOf(TableRow)).apply(this, arguments));
  }

  _createClass(TableRow, [{
    key: 'render',
    value: function render() {
      var _props8 = this.props,
          children = _props8.children,
          _props8$className = _props8.className,
          className = _props8$className === undefined ? '' : _props8$className,
          props = _objectWithoutProperties(_props8, ['children', 'className']);

      var isClickable = typeof props.onClick === 'function';
      return React.createElement(
        TableContext.Consumer,
        null,
        function (_ref2) {
          var columnProps = _ref2.columnProps;
          return React.createElement(
            'div',
            _extends({
              className: 'mt-table_row ' + (isClickable ? 'mt-table-clickableElement' : '') + ' ' + className,
              role: 'row'
            }, props),
            React.Children.map(children, function (child, index) {
              var childProps = columnProps && columnProps[index] ? columnProps[index] : {};
              return React.cloneElement(child, _extends({}, childProps));
            })
          );
        }
      );
    }
  }]);

  return TableRow;
}(Component);

var TableCell = function (_Component7) {
  _inherits(TableCell, _Component7);

  function TableCell() {
    _classCallCheck(this, TableCell);

    return _possibleConstructorReturn(this, (TableCell.__proto__ || Object.getPrototypeOf(TableCell)).apply(this, arguments));
  }

  _createClass(TableCell, [{
    key: 'render',
    value: function render() {
      var _props9 = this.props,
          children = _props9.children,
          _props9$className = _props9.className,
          className = _props9$className === undefined ? '' : _props9$className,
          _props9$rightBorder = _props9.rightBorder,
          rightBorder = _props9$rightBorder === undefined ? false : _props9$rightBorder,
          width = _props9.width,
          style = _props9.style,
          props = _objectWithoutProperties(_props9, ['children', 'className', 'rightBorder', 'width', 'style']);

      return React.createElement(
        'div',
        _extends({
          className: 'mt-table_cell ' + (rightBorder ? 'mt-table_cell-rightBorder' : '') + ' ' + className,
          role: 'cell',
          style: _extends({}, style, {
            minWidth: width ? width : null,
            maxWidth: width ? width : null
          })
        }, props),
        children
      );
    }
  }]);

  return TableCell;
}(Component);

var TableExpandedRowContent = function (_Component8) {
  _inherits(TableExpandedRowContent, _Component8);

  function TableExpandedRowContent() {
    var _ref3;

    var _temp2, _this8, _ret2;

    _classCallCheck(this, TableExpandedRowContent);

    for (var _len2 = arguments.length, args = Array(_len2), _key3 = 0; _key3 < _len2; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return _ret2 = (_temp2 = (_this8 = _possibleConstructorReturn(this, (_ref3 = TableExpandedRowContent.__proto__ || Object.getPrototypeOf(TableExpandedRowContent)).call.apply(_ref3, [this].concat(args))), _this8), _this8.getRef = function (el) {
      _this8.el = el;
    }, _temp2), _possibleConstructorReturn(_this8, _ret2);
  }

  _createClass(TableExpandedRowContent, [{
    key: 'render',
    value: function render() {
      var _props10 = this.props,
          _props10$className = _props10.className,
          className = _props10$className === undefined ? '' : _props10$className,
          children = _props10.children,
          open = _props10.open,
          props = _objectWithoutProperties(_props10, ['className', 'children', 'open']);

      return React.createElement(
        'div',
        _extends({
          className: 'mt-table_expandedRowContent ' + (open ? 'mt-table_expandedRowContent-open' : '') + className
        }, props, {
          ref: this.getRef }),
        children
      );
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (!this.el) return;
      var bb = this.el.getBoundingClientRect();
      this.el.style.setProperty('--mt-table-cellHeight', this.props.open ? bb.height + 'px' : 0);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var _this9 = this;

      if (!this.el) return;

      var initialBb = this.el.getBoundingClientRect();
      this.el.style.transition = 'none';
      this.el.style.display = 'block';
      this.el.style.height = 'auto';
      var bb = this.el.getBoundingClientRect();
      this.el.style.height = null;
      this.el.style.transition = null;
      this.el.style.display = null;

      if (!this.props.open) {
        if (initialBb.height) {
          this.el.style.setProperty('--mt-table-cellHeight', initialBb.height + 'px');
          requestAnimationFrame(function () {
            _this9.el && _this9.el.style.setProperty('--mt-table-cellHeight', 0);
          });
          return;
        }
        this.el.style.setProperty('--mt-table-cellHeight', 0);
        return;
      }

      requestAnimationFrame(function () {
        if (!_this9.el) return;
        _this9.el.style.setProperty('--mt-table-cellHeight', bb.height + 'px');
        _this9.el.addEventListener('transitionend', function () {
          _this9.el && _this9.el.style.setProperty('--mt-table-cellHeight', 'auto');
        }, { once: true });
      });
    }
  }]);

  return TableExpandedRowContent;
}(Component);

Table.Head = TableHead;
Table.HeadRow = WrappedTableHeadRow;
Table.HeadCell = TableHeadCell;
Table.Body = TableBody;
Table.Row = TableRow;
Table.Cell = TableCell;
Table.ExpandedRowContent = TableExpandedRowContent;