'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function clamp(min, val, max) {
  return Math.min(Math.max(min, val), max);
}

let Elevation = function (_Component) {
  _inherits(Elevation, _Component);

  function Elevation() {
    _classCallCheck(this, Elevation);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Elevation.prototype.render = function render() {
    var _props = this.props,
        _props$className = _props.className;
    const className = _props$className === undefined ? '' : _props$className;
    var _props$depth = _props.depth;

    const depth = _props$depth === undefined ? 1 : _props$depth,
          props = _objectWithoutProperties(_props, ['className', 'depth']);

    const depthToUse = Number.isNaN(depth) ? 1 : depth;
    const clampedDepth = clamp(0, depthToUse, 5);

    return _react2.default.createElement('div', _extends({
      className: `mt-elevation mt-elevation-${clampedDepth} ${className}`
    }, props));
  };

  return Elevation;
}(_react.Component);

Elevation.propTypes = {
  className: _propTypes2.default.string,
  depth: _propTypes2.default.oneOf([0, 1, 2, 3, 4, 5])
};

exports.default = Elevation;