'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ripple = require('../ripple/ripple');

var _ripple2 = _interopRequireDefault(_ripple);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let InputChip = function (_Component) {
  _inherits(InputChip, _Component);

  function InputChip(...args) {
    var _temp, _this, _ret;

    _classCallCheck(this, InputChip);

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call(this, ...args)), _this), _this.getRippleRef = component => {
      _this.rippleComponent = component;
    }, _this.onClose = e => {
      const onClose = _this.props.onClose;

      e.stopPropagation();
      onClose(e);
    }, _this.onClick = e => {
      const onClick = _this.props.onClick;


      if (_this.rippleComponent) {
        _this.rippleComponent.onClick(e);
      }

      if (onClick) {
        onClick();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  InputChip.prototype.render = function render() {
    var _props = this.props,
        _props$className = _props.className;
    const className = _props$className === undefined ? '' : _props$className,
          onClose = _props.onClose,
          icon = _props.icon;
    var _props$ripple = _props.ripple;

    const ripple = _props$ripple === undefined ? true : _props$ripple,
          children = _props.children,
          props = _objectWithoutProperties(_props, ['className', 'onClose', 'icon', 'ripple', 'children']);

    return _react2.default.createElement(
      'div',
      {
        className: `mt-chip ${props.onClick ? '' : 'mt-chip-notClickable'} ${className}`,
        onClick: this.onClick },
      icon && _react2.default.cloneElement(icon, {
        className: `mt-chip_icon ${icon.props.className}`
      }),
      _react2.default.createElement(
        'div',
        { className: 'mt-chip_chip' },
        children
      ),
      onClose && _react2.default.createElement(
        'svg',
        {
          xmlns: 'http://www.w3.org/2000/svg',
          className: 'mt-chip_closeIcon',
          onClick: this.onClose,
          width: '1em',
          height: '1em',
          viewBox: '0 0 48 48' },
        _react2.default.createElement('path', { d: 'M24 4C12.95 4 4 12.95 4 24s8.95 20 20 20 20-8.95 20-20S35.05 4 24 4zm10 27.17L31.17 34 24 26.83 16.83 34 14 31.17 21.17 24 14 16.83 16.83 14 24 21.17 31.17 14 34 16.83 26.83 24 34 31.17z' })
      ),
      ripple && props.onClick && _react2.default.createElement(_ripple2.default, { ref: this.getRippleRef })
    );
  };

  return InputChip;
}(_react.Component);

exports.default = InputChip;


InputChip.propTypes = {
  className: _propTypes2.default.string,
  icon: _propTypes2.default.element,
  ripple: _propTypes2.default.bool,
  onClose: _propTypes2.default.func,
  onClick: _propTypes2.default.func
};