'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ripple = require('../ripple/ripple');

var _ripple2 = _interopRequireDefault(_ripple);

var _elevation = require('../elevation/elevation');

var _elevation2 = _interopRequireDefault(_elevation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

let Menu = function (_Component) {
  _inherits(Menu, _Component);

  function Menu() {
    _classCallCheck(this, Menu);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Menu.prototype.render = function render() {
    var _props = this.props,
        _props$className = _props.className;

    const className = _props$className === undefined ? '' : _props$className,
          props = _objectWithoutProperties(_props, ['className']);

    return _react2.default.createElement(
      _elevation2.default,
      { depth: 1 },
      _react2.default.createElement('ul', _extends({ className: `mt-menu ${className}` }, props))
    );
  };

  return Menu;
}(_react.Component);

exports.default = Menu;


Menu.propTypes = {
  className: _propTypes2.default.string
};

let Item = function (_Component2) {
  _inherits(Item, _Component2);

  function Item(...args) {
    var _temp, _this2, _ret;

    _classCallCheck(this, Item);

    return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, _Component2.call(this, ...args)), _this2), _this2.getRippleRef = component => {
      _this2.rippleComponent = component;
    }, _this2.onClick = e => {
      const onClick = _this2.props.onClick;


      if (_this2.rippleComponent) {
        _this2.rippleComponent.onClick(e);
      }

      if (onClick) {
        onClick();
      }
    }, _temp), _possibleConstructorReturn(_this2, _ret);
  }

  Item.prototype.render = function render() {
    var _props2 = this.props,
        _props2$className = _props2.className;
    const className = _props2$className === undefined ? '' : _props2$className;
    var _props2$separator = _props2.separator;
    const separator = _props2$separator === undefined ? false : _props2$separator;
    var _props2$selected = _props2.selected;
    const selected = _props2$selected === undefined ? false : _props2$selected;
    var _props2$ripple = _props2.ripple;

    const ripple = _props2$ripple === undefined ? true : _props2$ripple,
          children = _props2.children,
          props = _objectWithoutProperties(_props2, ['className', 'separator', 'selected', 'ripple', 'children']);

    return _react2.default.createElement(
      'div',
      _extends({
        className: `mt-menu_item ${separator ? 'mt-menu_item-separator' : ''} ${selected ? 'mt-menu_item-selected' : ''} ${className}`
      }, props, {
        onClick: this.onClick }),
      children,
      ripple && _react2.default.createElement(_ripple2.default, { ref: this.getRippleRef })
    );
  };

  return Item;
}(_react.Component);

Item.propTypes = {
  className: _propTypes2.default.string,
  separator: _propTypes2.default.bool,
  selected: _propTypes2.default.bool,
  ripple: _propTypes2.default.bool
};

Menu.Item = Item;