'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

const TableContext = _react2.default.createContext({ columnProps: {} });

const columnInheritedProps = ['width', 'rightBorder'];

function areEqualShallow(a, b) {
  for (let key in a) {
    if (!(key in b) || a[key] !== b[key]) {
      return false;
    }
  }
  for (let key in b) {
    if (!(key in a) || a[key] !== b[key]) {
      return false;
    }
  }
  return true;
}

let Table = function (_Component) {
  _inherits(Table, _Component);

  function Table(...args) {
    var _temp, _this, _ret;

    _classCallCheck(this, Table);

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call(this, ...args)), _this), _this.setColumnsProps = map => {
      _this.setState(state => ({
        context: _extends({}, state.context, {
          columnProps: map
        })
      }));
    }, _this.state = {
      context: {
        columnProps: {},
        setColumnsProps: _this.setColumnsProps
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Table.prototype.render = function render() {
    var _props = this.props;
    const children = _props.children;
    var _props$loading = _props.loading;
    const loading = _props$loading === undefined ? false : _props$loading;
    var _props$className = _props.className;

    const className = _props$className === undefined ? '' : _props$className,
          props = _objectWithoutProperties(_props, ['children', 'loading', 'className']);

    return _react2.default.createElement(
      TableContext.Provider,
      { value: this.state.context },
      _react2.default.createElement(
        'div',
        _extends({
          className: `mt-table ${loading ? 'mt-table-loading' : ''} ${className}`,
          role: 'table'
        }, props),
        children
      )
    );
  };

  return Table;
}(_react.Component);

exports.default = Table;

let TableHead = function (_Component2) {
  _inherits(TableHead, _Component2);

  function TableHead() {
    _classCallCheck(this, TableHead);

    return _possibleConstructorReturn(this, _Component2.apply(this, arguments));
  }

  TableHead.prototype.render = function render() {
    var _props2 = this.props;
    const children = _props2.children;
    var _props2$className = _props2.className;

    const className = _props2$className === undefined ? '' : _props2$className,
          props = _objectWithoutProperties(_props2, ['children', 'className']);

    return _react2.default.createElement(
      'div',
      _extends({
        className: `mt-table_header ${className}`,
        role: 'rowgroup'
      }, props),
      children
    );
  };

  return TableHead;
}(_react.Component);

let TableHeadRow = function (_Component3) {
  _inherits(TableHeadRow, _Component3);

  function TableHeadRow() {
    _classCallCheck(this, TableHeadRow);

    return _possibleConstructorReturn(this, _Component3.apply(this, arguments));
  }

  TableHeadRow.prototype.render = function render() {
    var _props3 = this.props;
    const children = _props3.children;
    var _props3$className = _props3.className;

    const className = _props3$className === undefined ? '' : _props3$className,
          columnProps = _props3.columnProps,
          setColumnsProps = _props3.setColumnsProps,
          props = _objectWithoutProperties(_props3, ['children', 'className', 'columnProps', 'setColumnsProps']);

    return _react2.default.createElement(
      'div',
      _extends({
        className: `mt-table_row mt-table_headerRow ${className}`,
        role: 'row'
      }, props),
      children
    );
  };

  TableHeadRow.prototype.componentDidMount = function componentDidMount() {
    var _props4 = this.props;
    const children = _props4.children,
          setColumnsProps = _props4.setColumnsProps;

    const map = {};
    _react2.default.Children.forEach(children, (child, index) => {
      Object.keys(child.props).forEach(propName => {
        if (columnInheritedProps.includes(propName)) {
          map[index] = map[index] || {};
          map[index][propName] = child.props[propName];
        }
      });
    });
    setColumnsProps(map);
  };

  TableHeadRow.prototype.componentDidUpdate = function componentDidUpdate() {
    var _props5 = this.props;
    const children = _props5.children,
          setColumnsProps = _props5.setColumnsProps,
          columnProps = _props5.columnProps;

    const map = {};
    _react2.default.Children.forEach(children, (child, index) => {
      Object.keys(child.props).forEach(propName => {
        if (columnInheritedProps.includes(propName)) {
          map[index] = map[index] || {};
          map[index][propName] = child.props[propName];
        }
      });
    });

    //Object is empty
    if (Object.keys(map).length === 0 && map.constructor === Object) {
      return;
    }

    for (const prop in map) {
      if (map.hasOwnProperty(prop)) {
        if (!areEqualShallow(map, columnProps)) return;
      }
    }

    setColumnsProps(map);
  };

  return TableHeadRow;
}(_react.Component);

const WrappedTableHeadRow = props => {
  return _react2.default.createElement(
    TableContext.Consumer,
    null,
    ctxProps => _react2.default.createElement(TableHeadRow, _extends({}, props, ctxProps))
  );
};

let TableHeadCell = function (_Component4) {
  _inherits(TableHeadCell, _Component4);

  function TableHeadCell() {
    _classCallCheck(this, TableHeadCell);

    return _possibleConstructorReturn(this, _Component4.apply(this, arguments));
  }

  TableHeadCell.prototype.render = function render() {
    var _props6 = this.props;
    const children = _props6.children;
    var _props6$className = _props6.className;

    const className = _props6$className === undefined ? '' : _props6$className,
          props = _objectWithoutProperties(_props6, ['children', 'className']);

    return _react2.default.createElement(
      TableCell,
      _extends({
        className: `mt-table_headerCell ${className}`,
        role: 'columnheader'
      }, props),
      _react2.default.createElement(
        'div',
        { className: 'mt-table_headerCellContent' },
        children
      )
    );
  };

  return TableHeadCell;
}(_react.Component);

let TableBody = function (_Component5) {
  _inherits(TableBody, _Component5);

  function TableBody() {
    _classCallCheck(this, TableBody);

    return _possibleConstructorReturn(this, _Component5.apply(this, arguments));
  }

  TableBody.prototype.render = function render() {
    var _props7 = this.props,
        _props7$className = _props7.className;

    const className = _props7$className === undefined ? '' : _props7$className,
          children = _props7.children,
          props = _objectWithoutProperties(_props7, ['className', 'children']);

    return _react2.default.createElement(
      'div',
      _extends({ className: `mt-table_body ${className}`, role: 'rowgroup' }, props),
      children
    );
  };

  return TableBody;
}(_react.Component);

let TableRow = function (_Component6) {
  _inherits(TableRow, _Component6);

  function TableRow() {
    _classCallCheck(this, TableRow);

    return _possibleConstructorReturn(this, _Component6.apply(this, arguments));
  }

  TableRow.prototype.render = function render() {
    var _props8 = this.props;
    const children = _props8.children;
    var _props8$className = _props8.className;

    const className = _props8$className === undefined ? '' : _props8$className,
          props = _objectWithoutProperties(_props8, ['children', 'className']);

    const isClickable = typeof props.onClick === 'function';
    return _react2.default.createElement(
      TableContext.Consumer,
      null,
      ({ columnProps }) => _react2.default.createElement(
        'div',
        _extends({
          className: `mt-table_row ${isClickable ? 'mt-table-clickableElement' : ''} ${className}`,
          role: 'row'
        }, props),
        _react2.default.Children.map(children, (child, index) => {
          const childProps = columnProps && columnProps[index] ? columnProps[index] : {};
          return _react2.default.cloneElement(child, _extends({}, childProps));
        })
      )
    );
  };

  return TableRow;
}(_react.Component);

let TableCell = function (_Component7) {
  _inherits(TableCell, _Component7);

  function TableCell() {
    _classCallCheck(this, TableCell);

    return _possibleConstructorReturn(this, _Component7.apply(this, arguments));
  }

  TableCell.prototype.render = function render() {
    var _props9 = this.props;
    const children = _props9.children;
    var _props9$className = _props9.className;
    const className = _props9$className === undefined ? '' : _props9$className;
    var _props9$rightBorder = _props9.rightBorder;

    const rightBorder = _props9$rightBorder === undefined ? false : _props9$rightBorder,
          width = _props9.width,
          style = _props9.style,
          props = _objectWithoutProperties(_props9, ['children', 'className', 'rightBorder', 'width', 'style']);

    return _react2.default.createElement(
      'div',
      _extends({
        className: `mt-table_cell ${rightBorder ? 'mt-table_cell-rightBorder' : ''} ${className}`,
        role: 'cell',
        style: _extends({}, style, {
          minWidth: width ? width : null,
          maxWidth: width ? width : null
        })
      }, props),
      children
    );
  };

  return TableCell;
}(_react.Component);

let TableExpandedRowContent = function (_Component8) {
  _inherits(TableExpandedRowContent, _Component8);

  function TableExpandedRowContent(...args) {
    var _temp2, _this8, _ret2;

    _classCallCheck(this, TableExpandedRowContent);

    return _ret2 = (_temp2 = (_this8 = _possibleConstructorReturn(this, _Component8.call(this, ...args)), _this8), _this8.getRef = el => {
      _this8.el = el;
    }, _temp2), _possibleConstructorReturn(_this8, _ret2);
  }

  TableExpandedRowContent.prototype.render = function render() {
    var _props10 = this.props,
        _props10$className = _props10.className;

    const className = _props10$className === undefined ? '' : _props10$className,
          children = _props10.children,
          open = _props10.open,
          props = _objectWithoutProperties(_props10, ['className', 'children', 'open']);

    return _react2.default.createElement(
      'div',
      _extends({
        className: `mt-table_expandedRowContent ${open ? 'mt-table_expandedRowContent-open' : ''}${className}`
      }, props, {
        ref: this.getRef }),
      children
    );
  };

  TableExpandedRowContent.prototype.componentDidMount = function componentDidMount() {
    if (!this.el) return;
    const bb = this.el.getBoundingClientRect();
    this.el.style.setProperty('--mt-table-cellHeight', this.props.open ? `${bb.height}px` : 0);
  };

  TableExpandedRowContent.prototype.componentDidUpdate = function componentDidUpdate() {
    if (!this.el) return;

    const initialBb = this.el.getBoundingClientRect();
    this.el.style.transition = 'none';
    this.el.style.display = 'block';
    this.el.style.height = 'auto';
    const bb = this.el.getBoundingClientRect();
    this.el.style.height = null;
    this.el.style.transition = null;
    this.el.style.display = null;

    if (!this.props.open) {
      if (initialBb.height) {
        this.el.style.setProperty('--mt-table-cellHeight', `${initialBb.height}px`);
        requestAnimationFrame(() => {
          this.el && this.el.style.setProperty('--mt-table-cellHeight', 0);
        });
        return;
      }
      this.el.style.setProperty('--mt-table-cellHeight', 0);
      return;
    }

    requestAnimationFrame(() => {
      if (!this.el) return;
      this.el.style.setProperty('--mt-table-cellHeight', `${bb.height}px`);
      this.el.addEventListener('transitionend', () => {
        this.el && this.el.style.setProperty('--mt-table-cellHeight', 'auto');
      }, { once: true });
    });
  };

  return TableExpandedRowContent;
}(_react.Component);

Table.Head = TableHead;
Table.HeadRow = WrappedTableHeadRow;
Table.HeadCell = TableHeadCell;
Table.Body = TableBody;
Table.Row = TableRow;
Table.Cell = TableCell;
Table.ExpandedRowContent = TableExpandedRowContent;